#include "iut.h"
#include "user.h"
#include <unistd.h>
#include <errno.h>

int user2iut[2];
int iut2user[2];

int main (int argc, char *argv[])
{
  int PId;
  
  if (pipe(user2iut) == -1) {
    perror("pipe 'user2iut' failed");
    exit(1);
  }  

  if (pipe(iut2user) == -1) {
    close(user2iut[0]);
    close(user2iut[1]);
    perror("pipe 'iut2user' failed");
    exit(1);
  }  
  
  if ((PId = fork()) == -1)
  {
    perror("fork creation failed");
    return(-1);
  }
  
  if (PId) {
    int rvalue;
    close(user2iut[0]);
    close(iut2user[1]);
    rvalue = user();
    close(user2iut[1]);
    close(iut2user[0]);
  }
  else
  {
    int rvalue;
    close(user2iut[1]);
    close(iut2user[0]);
    rvalue = iut(argv);
    close(user2iut[0]);
    close(iut2user[1]);
  }
  return;
}

