#!/Window/X11R6/contrib/bin/wish8.3

# Version	: 1.0
# Date		: Wed Feb 27 16:09:52 MET DST 2001
# Author	: Jan Feenstra (e-mail: feenstra@cs.utwente.nl)


# global variables
if ![info exists confprot(nickname)] {set confprot(nickname) "anonymous"}
if ![info exists confprot(conference)] {set confprot(conference) "coffee"}
if ![info exists confprot(msg)] {set confprot(msg) ""}
if ![info exists confprot(active)] {set confprot(active) 0}

# Create Menubar {File Options}
menu .menubar

# attach menubar to the main window
. config -menu .menubar

# Create showbutton on menubar
set Exit [menu .menubar.mExit]
.menubar add command -label Exit -command Menu->Exit

# Create a text widget 't' to log the output
frame .t

set c [frame .t.user]
# Create nickname field
message $c.labnick -width 200 -text " nickname:"
entry $c.nickname -width 10 -textvariable confprot(nickname)
message $c.labconf -width 200 -text " conference:"
entry $c.conference -width 10 -textvariable confprot(conference)
message $c.labmsg -width 200 -text " message:"
entry $c.msg -width 70 -textvariable confprot(msg)
pack $c.labnick $c.nickname $c.labconf $c.conference $c.labmsg $c.msg -side left
pack .t.user -side top -fill x -expand true

set d [frame .t.line]
button $d.join -text JOIN -command Action->Join
button $d.leave -text LEAVE -command Action->Leave
button $d.send -text SEND -command Action->Send
button $d.receive -text RECEIVE -command Action->Receive
pack $d.join $d.leave $d.send $d.receive  -side left
pack .t.line -side top -fill x -expand true

set log [text .t.log -width 132 -height 50 -borderwidth 2 -setgrid true \
  -yscrollcommand {.t.scroll set}]
scrollbar .t.scroll -command {.t.log yview}
pack .t.scroll -side right -fill y
pack .t.log -side left -fill both -expand true
pack .t -side top -fill both -expand true

bind .t.user.msg <Return> Action->Send
focus .t.user.msg

#open the conference protocol implementation
#if {[catch {open "|echo.tcl" r+} channel]} {
#	$log insert end $channel\n
#} else {
#	fileevent $channel readable Log
#	$log insert end $channel\n
#}
set channel [open "|cpe  |& cat" r+]
fconfigure $channel -translation binary
fconfigure $channel -blocking 0
fileevent $channel readable Log
$log insert end $channel\n

proc Log {} {
	global log channel
  
	if {[eof $channel]} {
		close $channel
		exit
	} else {
		gets $channel line
		$log insert end $line\n
		$log see end
	}
}

#Call back function
proc Menu->Exit {} {
	exit
}

proc Action->Join {} {
	global log channel confprot line
	
	set line "join $confprot(nickname) $confprot(conference)"
	$log insert end $line
	$log see end
	puts $channel $line
	flush $channel
}

proc Action->Leave {} {
	global log channel confprot line
	
	set line "leave"
	$log insert end $line
	$log see end
	puts $channel $line
	flush $channel
}

proc Action->Send {} {
	global log channel confprot line
	
	set line "s $confprot(msg)"
	$log insert end $line
	$log see end
	puts $channel $line
	flush $channel
}

proc Action->Receive {} {
	global log channel confprot line
	
	gets $channel line
	$log insert end $line\n
	$log see end
}
